// 013 u_ib_join
// 25 mar 2004

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com


(*$r+*)
unit u_ib_join;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Db, DBTables, Grids, DBGrids, ComCtrls,
  IBCustomDataSet, IBQuery, IBDatabase, IBTable, IBUpdateSQL;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    IBTransaction1: TIBTransaction;
    IBQuery1: TIBQuery;
    Panel4: TPanel;
    Memo1: TMemo;
    DBGrid1: TDBGrid;
    join_: TButton;
    IBDatabase1: TIBDatabase;
    formations_: TButton;
    dates_: TButton;
    villes_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure join_Click(Sender: TObject);
    procedure formations_Click(Sender: TObject);
    procedure dates_Click(Sender: TObject);
    procedure villes_Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
  uses u_c_log, u_c_display
    ;

{$R *.DFM}


    const k_formations= 'SELECT * FROM formations';
          k_dates= 'SELECT * FROM dates';
          k_villes= 'SELECT * FROM villes';

          k_join=
              'SELECT f_numero, f_nom, d_date, v_nom'
            + ' FROM formations, dates, villes '
            + ' WHERE'
            + '   f_numero= d_formation'
            + '   AND d_ville= v_numero'
            + '   AND f_nom= ''Interbase Delphi'' ';

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure select(p_sql: String);
      begin
        display(p_sql);

        with Form1, IbQuery1 do
        begin
          Close;

          with Sql do
          begin
            Text:= p_sql;
            Open;
          end; // with Sql
        end; // with IbQuery1
      end; // select_Click

    procedure TForm1.formations_Click(Sender: TObject);
      begin
        select(k_formations);
      end; // formations_Click

    procedure TForm1.dates_Click(Sender: TObject);
      begin
        select(k_dates);
      end; // dates_Click

    procedure TForm1.villes_Click(Sender: TObject);
      begin
        select(k_villes);
      end; // villes_Click

    procedure TForm1.join_Click(Sender: TObject);
      begin
        select(k_join);
      end; // select_Click
end.


